#!/bin/sh
RPM_INSTALL_PREFIX=
export RPM_INSTALL_PREFIX

# create the zenoss group 
add_group() {
    # create the zenoss group and move the zenoss user into the group
    GROUP=`cat /etc/group | cut -d: -f1 | grep zenoss`
    EXISTS=$?
    if [ $EXISTS -eq 1 ]; then
        /usr/sbin/groupadd zenoss
    fi
}

# add the zenoss user
add_user() {
    /usr/sbin/useradd -r -m -c "Zenoss Account" \
            -u 1337 \
            -g zenoss \
            -d /home/zenoss \
            -s /bin/bash \
            -p \$1\$5afX49ZL\$sx0UlhhU9QZwbE/howDLk. \
            zenoss 
    [ $? = 0 -o $? = 9 ] # Ignore "user already exists" error #9.
}

# move the zenoss user into the zenoss group
set_group() {
    /usr/sbin/usermod -g zenoss zenoss
}


# called when we are upgrading or reinstalling (but not erasing, or installing)
if [ $1 -eq 2 ]; then
    # back up the conf files
    TEMP_DIR=/tmp/zenossrpmupgrade/$$
    mkdir -p $TEMP_DIR
    cp ${ZENHOME}/etc/*.conf $TEMP_DIR
    echo $TEMP_DIR > /tmp/zenossrpmupgrade/dirname.txt

    # add the zenoss group and move the zenoss user into the group
    add_group
    set_group
fi

# called when we are installing (but not erasing, upgrading, or reinstalling)
if [ $1 -eq 1 ]; then
    # add the zenoss group and the zenoss user
    add_group
    add_user
fi


# -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=